#include <iostream>

using namespace std;
int b[1000000], a[1000000];

long long stepen(int s, int c)
{
    int t=c;
    for(int i=1; i<s; i++)
    {
        t*=c;
    }
    return t;
}
int main()
{
    int n, m, c;
    cin>>n>>m;
    for(int i=1; i<=m; i++)
    {
        cin>>b[i];
    }
    cin>>c;
    for(int i=1; i<=n; i++)
    {
        a[i]=i;
    }
    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    long long zbir=0;
    for(int i=1; i<=n; i++)
    {
       zbir+=stepen(i, c)*a[i];
       if(zbir>=998244353)
       {
           zbir-=998244353;
       }
    }
    cout<<zbir;
    return 0;
}